import { Time } from '../models/types/time';
import { BetweenDate } from '../models/types/between-date';
import { WeekStartDay } from '../models/types/week-start-day';
import { SupportedLocale } from '../models/types/supported-locales';
export declare class TcDate {
    private date;
    constructor(date?: Date | string, format?: string);
    toDate(): Date;
    format(template: string, locale?: SupportedLocale): string;
    add(amount: number, type: Time): TcDate;
    subtract(amount: number, type: Time): TcDate;
    diff(start: Date, type: Time): number;
    startOf(type: Time, weekStartDay?: WeekStartDay): TcDate;
    endOf(type: Time, weekStartDay?: WeekStartDay): TcDate;
    weekday(): number;
    weekdayToDate(day: number, weekStartDay: WeekStartDay): Date;
    week(weekStartDay: WeekStartDay): number;
    year(): number;
    isSame(dateToCheck: Date, type: Time, weekStartDay?: WeekStartDay): boolean;
    isBetween({ start, end }: BetweenDate): boolean;
    isAfter(dateToCheck: Date): boolean;
    isValid(): boolean;
    set(amount: number, type: Time): TcDate;
    daysInMonth(): number;
    toISOString(): string;
    interval(start: Date, end: Date): Date[];
    getWeekDates: (weekStartDay?: WeekStartDay) => Date[];
    getDayShortName: (locale?: "nl-NL" | "en-US" | undefined) => string;
    getYearMonthDayKey: () => string;
    getDateOfWeek: (week: number, year: number) => Date;
    getDateOfIsoWeek: (week: number, year: number) => Date;
    getIsoWeekAndYear: () => {
        year: number;
        week: number;
        day: number;
    };
    getISODay: () => number;
    getISOYear: () => number;
    getIsoWeek: () => number;
    getDateWithoutTimeAsUTC: () => Date;
}
